//
//  UnusedViewController.m
//  PocketShop
//
//  Created by lujh on 2016/11/11.
//  Copyright © 2016年 卢家浩. All rights reserved.
//

#import "UnusedViewController.h"
#import "VourcherTableViewCell.h"
#import "VoucherList.h"

@interface UnusedViewController ()<UITableViewDelegate,UITableViewDataSource,ShowOrHiddenActivityDelegate>

@property(nonatomic,strong)UITableView *tableView;

@property(nonatomic,copy)NSMutableArray *data;
@property(nonatomic,copy)NSMutableArray *stateArray;
@property(nonatomic,assign)NSUInteger currentPage;

@property(nonatomic,strong)NSIndexPath *lastClickCellIndexPath;

@end

@implementation UnusedViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.view.backgroundColor = [UIColor cyanColor];
    
    //初始化变量
    [self initVar];
    
    
    [self getData];
    
    self.tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, UIScreenWidth, UIScreenHeight -kTabbar -kNavigationBar -60 -kStateBar) style:UITableViewStylePlain];
    self.tableView.delegate = self;
    self.tableView.dataSource = self;
    self.tableView.backgroundColor = [UIColor purpleColor];
    [self.view addSubview:self.tableView];
    
}

- (void)initVar {
    
    self.title = @"卡券";
    
    _data = [[NSMutableArray alloc] init];
    _stateArray = [NSMutableArray array];
    _currentPage = 1;
    
}

- (void)getData {
    
    [self showLoading:YES];
    NSMutableDictionary *params = [[NSMutableDictionary alloc] init];
    [params setObject:@"229" forKey:@"card_id"];
    [params setObject:@"134962" forKey:@"user_id"];
    [params setObject:[NSString stringWithFormat:@"%zd",_currentPage] forKey:@"p"];
    [HttpRequestClient requestWithURL2:kAPIKaBaoUserShoppingList params:params httpMethod:@"GET" completeBlock:^(id data) {
        
        
        NSInteger res  = [[data objectForKey:@"res"]integerValue];
        
        if (res == 0) {
            
            NSArray *arr = [data objectForKey:@"data"];
            
            for (NSDictionary *dict in arr) {
                
                VoucherList *voucherList = [VoucherList mj_objectWithKeyValues:dict];
                [_data addObject:voucherList];
            }

            [self.tableView reloadData];
        }
        
    } failedBlock:^(NSError *error) {
        
        [self showLoading:NO];
        
        
        [SGInfoAlert showInfo:kErrorOrNoNetWork
                      bgColor:[UIColor orangeColor].CGColor
                       inView:self.view
                     vertical:0.8];
        
    }];
    
    
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    
   
      VoucherList *voucherList = _data[indexPath.row];

    if (voucherList.isOpen ==NO) {
        
        return 100 ;
    }
    
       return voucherList.cellHeight +10;

    
}

-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {

    return _data.count;
}


-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {

    VourcherTableViewCell  *cell = [tableView dequeueReusableCellWithIdentifier:@"cell" ];
    
    if (cell == nil) {
        cell = [[VourcherTableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:@"cell"];
    }
    
    cell.voucherList = _data[indexPath.row];
    
    cell.showOrHiddenActivityDelegate = self;
    
    cell.indexPath = indexPath;
    
    return cell;

}

-(void)showOrHiddenActivity:(VourcherTableViewCell *)cell clickedAtIndexPath:(NSIndexPath *)indexPath{

    //处理上一次打开的cell
    if (self.lastClickCellIndexPath != nil) {
        
        VoucherList *model = self.data[self.lastClickCellIndexPath.row] ;
        
        if (model.isOpen&&(self.lastClickCellIndexPath!= indexPath)) {
            
            model.isOpen = !model.isOpen;
            
        }
    }
    
    VoucherList *model = self.data[indexPath.row] ;
    
    model.isOpen = !model.isOpen;
    
    [self.tableView reloadData];
    
    self.lastClickCellIndexPath = indexPath;
    
}

@end
