//
//  VourcherTableViewCell.m
//  cell点击活动按钮展开收缩
//
//  Created by lujh on 16/7/20.
//  Copyright © 2016年 卢家浩. All rights reserved.
//
#define UIScreenWidth   [[UIScreen mainScreen]bounds].size.width
#import "VourcherTableViewCell.h"
#import "DetailInformation.h"

@implementation VourcherTableViewCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
        
        [self initSubView];
        
    }
    return self;
}

- (void)initSubView {
    
    //整个背景view
    _backView = [[UIView alloc] init];
    _backView.frame = CGRectMake(0, 10, UIScreenWidth, 90);
    _backView.backgroundColor = [UIColor cyanColor];
    [self.contentView addSubview:_backView];
    
    //详细信息按钮view
    _btnView = [[UIView alloc] init];
    CGFloat btnViewW = UIScreenWidth -24;
    CGFloat btnViewX =12;
    CGFloat btnViewH = 36;
    _btnView.frame = CGRectMake(btnViewX, 90-36, btnViewW, btnViewH);
    _btnView.userInteractionEnabled = YES;
    UITapGestureRecognizer *tap =  [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(tapClick:)];
    [self.btnView addGestureRecognizer:tap];
    _btnView.backgroundColor = [UIColor redColor];
    [_backView addSubview:_btnView];
    
}

-(void)setVoucherList:(VoucherList *)voucherList {
    
    _voucherList = voucherList;
    
    if (voucherList.isOpen) {
        
        _backView.frame = CGRectMake(0, 10, UIScreenWidth,voucherList.cellHeight);


    }else{
        
        _backView.frame = CGRectMake(0, 10, UIScreenWidth,90);

    }
    
    //重新设置背景view的frame
    
}

- (void)tapClick:(UITapGestureRecognizer*)gesture {
    
    if ([self.showOrHiddenActivityDelegate respondsToSelector:@selector(showOrHiddenActivity: clickedAtIndexPath:)]) {
        
         [self.showOrHiddenActivityDelegate showOrHiddenActivity:self clickedAtIndexPath:self.indexPath];
       }
}

@end
