//
//  ViewController.m
//  cell模型计算高度点击伸缩
//
//  Created by 家浩 on 2016/11/19.
//  Copyright © 2016年 北京思创银联. All rights reserved.
//

#import "ViewController.h"
#import "VourcherTableViewCell.h"
#import "VoucherList.h"
#import "AFNetworking.h"
#import "MJExtension.h"
@interface ViewController ()<UITableViewDelegate,UITableViewDataSource,ShowOrHiddenActivityDelegate>

@property(nonatomic,strong)UITableView *tableView;

@property(nonatomic,copy)NSMutableArray *data;
@property(nonatomic,copy)NSMutableArray *stateArray;
@property(nonatomic,assign)NSUInteger currentPage;

@property(nonatomic,strong)NSIndexPath *lastClickCellIndexPath;



@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.view.backgroundColor = [UIColor cyanColor];
    
    //初始化变量
    [self initVar];
    
    
    [self getData];
    
    self.tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height) style:UITableViewStylePlain];
    self.tableView.delegate = self;
    self.tableView.dataSource = self;
    self.tableView.backgroundColor = [UIColor purpleColor];
    
    [self.view addSubview:self.tableView];
    
}

- (void)initVar {
    
    self.title = @"卡券";
    
    _data = [[NSMutableArray alloc] init];
    _stateArray = [NSMutableArray array];
    _currentPage = 1;
    
}

- (void)getData {
    NSMutableDictionary *params = [[NSMutableDictionary alloc] init];
    [params setObject:@"229" forKey:@"card_id"];
    [params setObject:@"134962" forKey:@"user_id"];
    [params setObject:[NSString stringWithFormat:@"%zd",_currentPage] forKey:@"p"];
    
    
    AFHTTPSessionManager *manger = [AFHTTPSessionManager manager];
    [manger.requestSerializer willChangeValueForKey:@"timeoutInterval"];
    manger.requestSerializer.timeoutInterval = 30;
    [manger.requestSerializer didChangeValueForKey:@"timeoutInterval"];
    //返回的数据格式 跟 返回数据header中定义的格式不一致
    manger.responseSerializer.acceptableContentTypes = [NSSet setWithObject:@"text/html"];
    
    [manger GET:@"http://139.217.11.18:81/O2OV2_test/user/index.php?&m=Card&&a=spend_card_list" parameters:params success:^(NSURLSessionDataTask * _Nonnull task, id  _Nonnull responseObject) {
        NSInteger res  = [[responseObject objectForKey:@"res"]integerValue];
        
        if (res == 0) {
            
            NSArray *arr = [responseObject objectForKey:@"data"];
            
            for (NSDictionary *dict in arr) {
                
                VoucherList *voucherList = [VoucherList mj_objectWithKeyValues:dict];
                [_data addObject:voucherList];
            }
            
            [self.tableView reloadData];
        }
        
        
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        
    }];
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    
    VoucherList *voucherList = _data[indexPath.row];
    
    if (voucherList.isOpen ==NO) {
        
        return 100 ;
    }
    
    return voucherList.cellHeight +10;
    
    
}

-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    
    return _data.count;
}


-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    VourcherTableViewCell  *cell = [tableView dequeueReusableCellWithIdentifier:@"cell" ];
    
    if (cell == nil) {
        cell = [[VourcherTableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:@"cell"];
    }
    
    cell.voucherList = _data[indexPath.row];
    
    cell.showOrHiddenActivityDelegate = self;
    
    cell.indexPath = indexPath;
    
    return cell;
    
}

-(void)showOrHiddenActivity:(VourcherTableViewCell *)cell clickedAtIndexPath:(NSIndexPath *)indexPath{
    
    //处理上一次打开的cell
    if (self.lastClickCellIndexPath != nil) {
        
        VoucherList *model = self.data[self.lastClickCellIndexPath.row] ;
        
        if (model.isOpen&&(self.lastClickCellIndexPath!= indexPath)) {
            
            model.isOpen = !model.isOpen;
            
        }
    }
    
    VoucherList *model = self.data[indexPath.row] ;
    
    model.isOpen = !model.isOpen;
    
    [self.tableView reloadData];
    
    self.lastClickCellIndexPath = indexPath;
    
}
@end
